Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Botan::ChaCha20Poly1305_Decryption Class Referencefinal

`#include <chacha20poly1305.h>`

Inheritance diagram for Botan::ChaCha20Poly1305_Decryption:

## Public Member Functions
bool | authenticated () const override
void | clear () override
size_t | default_nonce_length () const override
void | finish (secure_vector< uint8_t > &final_block, size_t offset=0) override
Key_Length_Specification | key_spec () const override
size_t | minimum_final_size () const override
std::string | name () const override
size_t | output_length (size_t input_length) const override
size_t | process (uint8_t buf[], size_t size) override
virtual std::string | provider () const
void | reset () override
template<typename Alloc >
void | set_ad (const std::vector< uint8_t, Alloc > &ad)
void | set_associated_data (const uint8_t ad[], size_t ad_len) override
template<typename Alloc >
void | set_associated_data_vec (const std::vector< uint8_t, Alloc > &ad)
template<typename Alloc >
void | set_key (const std::vector< uint8_t, Alloc > &key)
void | set_key (const SymmetricKey &key)
void | set_key (const uint8_t key[], size_t length)
template<typename Alloc >
void | start (const std::vector< uint8_t, Alloc > &nonce)
void | start (const uint8_t nonce[], size_t nonce_len)
void | start ()
size_t | tag_size () const override
void | update (secure_vector< uint8_t > &buffer, size_t offset=0)
size_t | update_granularity () const override
bool | valid_keylength (size_t length) const
bool | valid_nonce_length (size_t n) const override

## Protected Member Functions
bool | cfrg_version () const
void | update_len (size_t len)

## Protected Attributes
secure_vector< uint8_t > | m_ad
std::unique_ptr< StreamCipher > | m_chacha
size_t | m_ctext_len = 0
size_t | m_nonce_len = 0
std::unique_ptr< MessageAuthenticationCode > | m_poly1305

## Detailed Description

ChaCha20Poly1305 Decryption

Definition at line 81 of file chacha20poly1305.h.

## Member Function Documentation

bool Botan::AEAD_Mode::authenticated | ( |  | ) | const
| inline override virtual inherited

Returns
  true iff this mode provides authentication as well as confidentiality.

Reimplemented from Botan::Cipher_Mode.

Definition at line 25 of file aead.h.

25 { return true; }

bool Botan::ChaCha20Poly1305_Mode::cfrg_version | ( |  | ) | const
| inline protected inherited

Definition at line 54 of file chacha20poly1305.h.

Referenced by Botan::ChaCha20Poly1305_Encryption::finish(), and finish().

54 { return m_nonce_len == 12; }
Botan::ChaCha20Poly1305_Mode::m_nonce_len
size_t m_nonce_len
Definition: chacha20poly1305.h:51

void Botan::ChaCha20Poly1305_Mode::clear | ( |  | ) |
| override virtual inherited

Zeroise all state See also reset_msg()

Implements Botan::Cipher_Mode.

Definition at line 26 of file chacha20poly1305.cpp.

References Botan::ChaCha20Poly1305_Mode::m_chacha, Botan::ChaCha20Poly1305_Mode::m_poly1305, and Botan::ChaCha20Poly1305_Mode::reset().

27 {
28 m_chacha->clear();
29 m_poly1305->clear();
30 reset();
31 }
Botan::ChaCha20Poly1305_Mode::m_poly1305
std::unique_ptr< MessageAuthenticationCode > m_poly1305
Definition: chacha20poly1305.h:46
Botan::ChaCha20Poly1305_Mode::m_chacha
std::unique_ptr< StreamCipher > m_chacha
Definition: chacha20poly1305.h:45
Botan::ChaCha20Poly1305_Mode::reset
void reset() override
Definition: chacha20poly1305.cpp:33

size_t Botan::AEAD_Mode::default_nonce_length | ( |  | ) | const
| inline override virtual inherited

Returns
  default AEAD nonce size (a commonly supported value among AEAD modes, and large enough that random collisions are unlikely)

Implements Botan::Cipher_Mode.

Reimplemented in Botan::TLS::TLS_CBC_HMAC_AEAD_Mode, and Botan::CCM_Mode.

Definition at line 75 of file aead.h.

75 { return 12; }

void Botan::ChaCha20Poly1305_Decryption::finish | ( | secure_vector< uint8_t > & | final_block,
|  | size_t | offset = `0`
| ) |  |
| override virtual

Complete processing of a message.

Parameters

  final_block | in/out parameter which must be at least minimum_final_size() bytes, and will be set to any final output
  offset | an offset into final_block to begin processing

Implements Botan::Cipher_Mode.

Definition at line 126 of file chacha20poly1305.cpp.

References BOTAN_ASSERT, Botan::ChaCha20Poly1305_Mode::cfrg_version(), Botan::ChaCha20Poly1305_Mode::m_ad, Botan::ChaCha20Poly1305_Mode::m_chacha, Botan::ChaCha20Poly1305_Mode::m_ctext_len, Botan::ChaCha20Poly1305_Mode::m_poly1305, Botan::same_mem(), Botan::ChaCha20Poly1305_Mode::tag_size(), and Botan::ChaCha20Poly1305_Mode::update_len().

127 {
128 BOTAN_ASSERT(buffer.size() >= offset, "Offset is sane");
129 const size_t sz = buffer.size() - offset;
130 uint8_t* buf = buffer.data() + offset;
131
132 BOTAN_ASSERT(sz >= tag_size(), "Have the tag as part of final input");
133
134 const size_t remaining = sz - tag_size();
135
136 if(remaining)
137 {
138 m_poly1305->update(buf, remaining); // poly1305 of ciphertext
139 m_chacha->cipher1(buf, remaining);
140 m_ctext_len += remaining;
141 }
142
143 if(cfrg_version())
144 {
145 if(m_ctext_len % 16)
146 {
147 const uint8_t zeros[16] = { 0 };
148 m_poly1305->update(zeros, 16 - m_ctext_len % 16);
149 }
150 update_len(m_ad.size());
151 }
152
153 update_len(m_ctext_len);
154 const secure_vector<uint8_t> mac = m_poly1305->final();
155
156 const uint8_t* included_tag = &buf[remaining];
157
158 m_ctext_len = 0;
159
160 if(!same_mem(mac.data(), included_tag, tag_size()))
161 throw Integrity_Failure("ChaCha20Poly1305 tag check failed");
162 buffer.resize(offset + remaining);
163 }
Botan::same_mem
bool same_mem(const T *p1, const T *p2, size_t n)
Definition: mem_ops.h:98
Botan::ChaCha20Poly1305_Mode::m_poly1305
std::unique_ptr< MessageAuthenticationCode > m_poly1305
Definition: chacha20poly1305.h:46
Botan::ChaCha20Poly1305_Mode::m_chacha
std::unique_ptr< StreamCipher > m_chacha
Definition: chacha20poly1305.h:45
BOTAN_ASSERT
#define BOTAN_ASSERT(expr, assertion_made)
Definition: assert.h:27
Botan::ChaCha20Poly1305_Mode::tag_size
size_t tag_size() const override
Definition: chacha20poly1305.h:38
Botan::ChaCha20Poly1305_Mode::m_ad
secure_vector< uint8_t > m_ad
Definition: chacha20poly1305.h:50
Botan::ChaCha20Poly1305_Mode::cfrg_version
bool cfrg_version() const
Definition: chacha20poly1305.h:54
Botan::ChaCha20Poly1305_Mode::update_len
void update_len(size_t len)
Definition: chacha20poly1305.cpp:52
Botan::ChaCha20Poly1305_Mode::m_ctext_len
size_t m_ctext_len
Definition: chacha20poly1305.h:52

Key_Length_Specification Botan::ChaCha20Poly1305_Mode::key_spec | ( |  | ) | const
| inline override virtual inherited

Returns
  object describing limits on key size

Implements Botan::Cipher_Mode.

Definition at line 33 of file chacha20poly1305.h.

34 { return Key_Length_Specification(32); }

size_t Botan::ChaCha20Poly1305_Decryption::minimum_final_size | ( |  | ) | const
| inline override virtual

Returns
  required minimium size to finalize() - may be any length larger than this.

Implements Botan::Cipher_Mode.

Definition at line 90 of file chacha20poly1305.h.

90 { return tag_size(); }
Botan::ChaCha20Poly1305_Mode::tag_size
size_t tag_size() const override
Definition: chacha20poly1305.h:38

std::string Botan::ChaCha20Poly1305_Mode::name | ( |  | ) | const
| inline override virtual inherited

Implements Botan::Cipher_Mode.

Definition at line 29 of file chacha20poly1305.h.

29 { return "ChaCha20Poly1305"; }

size_t Botan::ChaCha20Poly1305_Decryption::output_length | ( | size_t | input_length | ) | const
| inline override virtual

Returns the size of the output if this transform is used to process a message with input_length bytes. Will throw if unable to give a precise answer.

Implements Botan::Cipher_Mode.

Definition at line 84 of file chacha20poly1305.h.

References BOTAN_ASSERT.

85 {
86 BOTAN_ASSERT(input_length >= tag_size(), "Sufficient input");
87 return input_length - tag_size();
88 }
BOTAN_ASSERT
#define BOTAN_ASSERT(expr, assertion_made)
Definition: assert.h:27
Botan::ChaCha20Poly1305_Mode::tag_size
size_t tag_size() const override
Definition: chacha20poly1305.h:38

size_t Botan::ChaCha20Poly1305_Decryption::process | ( | uint8_t | msg[],
|  | size_t | msg_len
| ) |  |
| override virtual

Process message blocks

Input must be a multiple of update_granularity

Processes msg in place and returns bytes written. Normally this will be either msg_len (indicating the entire message was processed) or for certain AEAD modes zero (indicating that the mode requires the entire message be processed in one pass).

Parameters

  msg | the message to be processed
  msg_len | length of the message in bytes

Implements Botan::Cipher_Mode.

Definition at line 118 of file chacha20poly1305.cpp.

References Botan::ChaCha20Poly1305_Mode::m_chacha, Botan::ChaCha20Poly1305_Mode::m_ctext_len, and Botan::ChaCha20Poly1305_Mode::m_poly1305.

119 {
120 m_poly1305->update(buf, sz); // poly1305 of ciphertext
121 m_chacha->cipher1(buf, sz);
122 m_ctext_len += sz;
123 return sz;
124 }
Botan::ChaCha20Poly1305_Mode::m_poly1305
std::unique_ptr< MessageAuthenticationCode > m_poly1305
Definition: chacha20poly1305.h:46
Botan::ChaCha20Poly1305_Mode::m_chacha
std::unique_ptr< StreamCipher > m_chacha
Definition: chacha20poly1305.h:45
Botan::ChaCha20Poly1305_Mode::m_ctext_len
size_t m_ctext_len
Definition: chacha20poly1305.h:52

virtual std::string Botan::Cipher_Mode::provider | ( |  | ) | const
| inline virtual inherited

Returns
  provider information about this implementation. Default is "base", might also return "sse2", "avx2", "openssl", or some other arbitrary string.

Reimplemented in Botan::GCM_Mode.

Definition at line 202 of file cipher_mode.h.

202 { return "base"; }

void Botan::ChaCha20Poly1305_Mode::reset | ( |  | ) |
| override virtual inherited

Resets just the message specific state and allows encrypting again under the existing key

Implements Botan::Cipher_Mode.

Definition at line 33 of file chacha20poly1305.cpp.

References Botan::ChaCha20Poly1305_Mode::m_ad, Botan::ChaCha20Poly1305_Mode::m_ctext_len, and Botan::ChaCha20Poly1305_Mode::m_nonce_len.

Referenced by Botan::ChaCha20Poly1305_Mode::clear().

34 {
35 m_ad.clear();
36 m_ctext_len = 0;
37 m_nonce_len = 0;
38 }
Botan::ChaCha20Poly1305_Mode::m_ad
secure_vector< uint8_t > m_ad
Definition: chacha20poly1305.h:50
Botan::ChaCha20Poly1305_Mode::m_nonce_len
size_t m_nonce_len
Definition: chacha20poly1305.h:51
Botan::ChaCha20Poly1305_Mode::m_ctext_len
size_t m_ctext_len
Definition: chacha20poly1305.h:52
template<typename Alloc >

void Botan::AEAD_Mode::set_ad | ( | const std::vector< uint8_t, Alloc > & | ad | ) |
| inline inherited

Set associated data that is not included in the ciphertext but that should be authenticated. Must be called after set_key and before start.

See set_associated_data().

Parameters

  ad | the associated data

Definition at line 66 of file aead.h.

Referenced by Botan::TLS::write_record().

67 {
68 set_associated_data(ad.data(), ad.size());
69 }
Botan::AEAD_Mode::set_associated_data
virtual void set_associated_data(const uint8_t ad[], size_t ad_len)=0

void Botan::ChaCha20Poly1305_Mode::set_associated_data | ( | const uint8_t | ad[],
|  | size_t | ad_len
| ) |  |
| override virtual inherited

Set associated data that is not included in the ciphertext but that should be authenticated. Must be called after set_key and before start.

Unless reset by another call, the associated data is kept between messages. Thus, if the AD does not change, calling once (after set_key) is the optimum.

Parameters

  ad | the associated data
  ad_len | length of add in bytes

Implements Botan::AEAD_Mode.

Definition at line 45 of file chacha20poly1305.cpp.

References Botan::ChaCha20Poly1305_Mode::m_ad, and Botan::ChaCha20Poly1305_Mode::m_ctext_len.

46 {
47 if(m_ctext_len)
48 throw Exception("Too late to set AD for ChaCha20Poly1305");
49 m_ad.assign(ad, ad + length);
50 }
Botan::ChaCha20Poly1305_Mode::m_ad
secure_vector< uint8_t > m_ad
Definition: chacha20poly1305.h:50
Botan::ChaCha20Poly1305_Mode::m_ctext_len
size_t m_ctext_len
Definition: chacha20poly1305.h:52
template<typename Alloc >

void Botan::AEAD_Mode::set_associated_data_vec | ( | const std::vector< uint8_t, Alloc > & | ad | ) |
| inline inherited

Set associated data that is not included in the ciphertext but that should be authenticated. Must be called after set_key and before start.

See set_associated_data().

Parameters

  ad | the associated data

Definition at line 51 of file aead.h.

52 {
53 set_associated_data(ad.data(), ad.size());
54 }
Botan::AEAD_Mode::set_associated_data
virtual void set_associated_data(const uint8_t ad[], size_t ad_len)=0
template<typename Alloc >

void Botan::Cipher_Mode::set_key | ( | const std::vector< uint8_t, Alloc > & | key | ) |
| inline inherited

Set the symmetric key of this transform

Parameters

  key | contains the key material

Definition at line 172 of file cipher_mode.h.

Referenced by botan_cipher_set_key().

173 {
174 set_key(key.data(), key.size());
175 }
Botan::Cipher_Mode::set_key
void set_key(const std::vector< uint8_t, Alloc > &key)
Definition: cipher_mode.h:172

void Botan::Cipher_Mode::set_key | ( | const SymmetricKey & | key | ) |
| inline inherited

Set the symmetric key of this transform

Parameters

  key | contains the key material

Definition at line 181 of file cipher_mode.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

182 {
183 set_key(key.begin(), key.length());
184 }
Botan::Cipher_Mode::set_key
void set_key(const std::vector< uint8_t, Alloc > &key)
Definition: cipher_mode.h:172

void Botan::Cipher_Mode::set_key | ( | const uint8_t | key[],
|  | size_t | length
| ) |  |
| inline inherited

Set the symmetric key of this transform

Parameters

  key | contains the key material
  length | in bytes of key param

Definition at line 191 of file cipher_mode.h.

192 {
193 if(!valid_keylength(length))
194 throw Invalid_Key_Length(name(), length);
195 key_schedule(key, length);
196 }
Botan::Cipher_Mode::name
virtual std::string name() const =0
Botan::Cipher_Mode::valid_keylength
bool valid_keylength(size_t length) const
Definition: cipher_mode.h:162
template<typename Alloc >

void Botan::Cipher_Mode::start | ( | const std::vector< uint8_t, Alloc > & | nonce | ) |
| inline inherited

Begin processing a message.

Parameters

  nonce | the per message nonce

Definition at line 38 of file cipher_mode.h.

Referenced by botan_cipher_start(), and Botan::TLS::write_record().

39 {
40 start_msg(nonce.data(), nonce.size());
41 }
Botan::Cipher_Mode::start_msg
virtual void start_msg(const uint8_t nonce[], size_t nonce_len)=0

void Botan::Cipher_Mode::start | ( | const uint8_t | nonce[],
|  | size_t | nonce_len
| ) |  |
| inline inherited

Begin processing a message.

Parameters

  nonce | the per message nonce
  nonce_len | length of nonce

Definition at line 48 of file cipher_mode.h.

49 {
50 start_msg(nonce, nonce_len);
51 }
Botan::Cipher_Mode::start_msg
virtual void start_msg(const uint8_t nonce[], size_t nonce_len)=0

void Botan::Cipher_Mode::start | ( |  | ) |
| inline inherited

Begin processing a message.

Definition at line 56 of file cipher_mode.h.

57 {
58 return start_msg(nullptr, 0);
59 }
Botan::Cipher_Mode::start_msg
virtual void start_msg(const uint8_t nonce[], size_t nonce_len)=0

size_t Botan::ChaCha20Poly1305_Mode::tag_size | ( |  | ) | const
| inline override virtual inherited

Returns
  the size of the authentication tag used (in bytes)

Reimplemented from Botan::Cipher_Mode.

Definition at line 38 of file chacha20poly1305.h.

Referenced by Botan::ChaCha20Poly1305_Encryption::finish(), and finish().

38 { return 16; }

void Botan::Cipher_Mode::update | ( | secure_vector< uint8_t > & | buffer,
|  | size_t | offset = `0`
| ) |  |
| inline inherited

Process some data. Input must be in size update_granularity() uint8_t blocks.

Parameters

  buffer | in/out parameter which will possibly be resized
  offset | an offset into blocks to begin processing

Definition at line 81 of file cipher_mode.h.

References BOTAN_ASSERT.

Referenced by botan_cipher_update(), Botan::XTS_Encryption::finish(), Botan::ChaCha20Poly1305_Encryption::finish(), Botan::CBC_Encryption::finish(), Botan::CFB_Encryption::finish(), Botan::EAX_Encryption::finish(), Botan::XTS_Decryption::finish(), Botan::CFB_Decryption::finish(), Botan::CTS_Encryption::finish(), Botan::CBC_Decryption::finish(), Botan::TLS::TLS_CBC_HMAC_AEAD_Encryption::finish(), Botan::CTS_Decryption::finish(), and Botan::TLS::TLS_CBC_HMAC_AEAD_Decryption::finish().

82 {
83 BOTAN_ASSERT(buffer.size() >= offset, "Offset ok");
84 uint8_t* buf = buffer.data() + offset;
85 const size_t buf_size = buffer.size() - offset;
86
87 const size_t written = process(buf, buf_size);
88 buffer.resize(offset + written);
89 }
BOTAN_ASSERT
#define BOTAN_ASSERT(expr, assertion_made)
Definition: assert.h:27
Botan::Cipher_Mode::process
virtual size_t process(uint8_t msg[], size_t msg_len)=0

size_t Botan::ChaCha20Poly1305_Mode::update_granularity | ( |  | ) | const
| inline override virtual inherited

Returns
  size of required blocks to update

Implements Botan::Cipher_Mode.

Definition at line 31 of file chacha20poly1305.h.

31 { return 64; }

void Botan::ChaCha20Poly1305_Mode::update_len | ( | size_t | len | ) |
| protected inherited

Definition at line 52 of file chacha20poly1305.cpp.

References Botan::ChaCha20Poly1305_Mode::m_poly1305, and Botan::store_le().

Referenced by Botan::ChaCha20Poly1305_Encryption::finish(), and finish().

53 {
54 uint8_t len8[8] = { 0 };
55 store_le(static_cast<uint64_t>(len), len8);
56 m_poly1305->update(len8, 8);
57 }
Botan::ChaCha20Poly1305_Mode::m_poly1305
std::unique_ptr< MessageAuthenticationCode > m_poly1305
Definition: chacha20poly1305.h:46
Botan::store_le
void store_le(uint16_t in, uint8_t out[2])
Definition: loadstor.h:457

bool Botan::Cipher_Mode::valid_keylength | ( | size_t | length | ) | const
| inline inherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 162 of file cipher_mode.h.

163 {
164 return key_spec().valid_keylength(length);
165 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::Cipher_Mode::key_spec
virtual Key_Length_Specification key_spec() const =0

bool Botan::ChaCha20Poly1305_Mode::valid_nonce_length | ( | size_t | nonce_len | ) | const
| override virtual inherited

Returns
  true iff nonce_len is a valid length for the nonce

Implements Botan::Cipher_Mode.

Definition at line 21 of file chacha20poly1305.cpp.

22 {
23 return (n == 8 || n == 12);
24 }

## Member Data Documentation

secure_vector<uint8_t> Botan::ChaCha20Poly1305_Mode::m_ad
| protected inherited

Definition at line 50 of file chacha20poly1305.h.

Referenced by Botan::ChaCha20Poly1305_Encryption::finish(), finish(), Botan::ChaCha20Poly1305_Mode::reset(), and Botan::ChaCha20Poly1305_Mode::set_associated_data().

std::unique_ptr<StreamCipher> Botan::ChaCha20Poly1305_Mode::m_chacha
| protected inherited

Definition at line 45 of file chacha20poly1305.h.

Referenced by Botan::ChaCha20Poly1305_Mode::ChaCha20Poly1305_Mode(), Botan::ChaCha20Poly1305_Mode::clear(), finish(), Botan::ChaCha20Poly1305_Encryption::process(), and process().

size_t Botan::ChaCha20Poly1305_Mode::m_ctext_len = 0
| protected inherited

Definition at line 52 of file chacha20poly1305.h.

Referenced by Botan::ChaCha20Poly1305_Encryption::finish(), finish(), Botan::ChaCha20Poly1305_Encryption::process(), process(), Botan::ChaCha20Poly1305_Mode::reset(), and Botan::ChaCha20Poly1305_Mode::set_associated_data().

size_t Botan::ChaCha20Poly1305_Mode::m_nonce_len = 0
| protected inherited

Definition at line 51 of file chacha20poly1305.h.

Referenced by Botan::ChaCha20Poly1305_Mode::reset().

std::unique_ptr<MessageAuthenticationCode> Botan::ChaCha20Poly1305_Mode::m_poly1305
| protected inherited

Definition at line 46 of file chacha20poly1305.h.

Referenced by Botan::ChaCha20Poly1305_Mode::ChaCha20Poly1305_Mode(), Botan::ChaCha20Poly1305_Mode::clear(), Botan::ChaCha20Poly1305_Encryption::finish(), finish(), Botan::ChaCha20Poly1305_Encryption::process(), process(), and Botan::ChaCha20Poly1305_Mode::update_len().

The documentation for this class was generated from the following files:

- src/lib/modes/aead/chacha20poly1305/chacha20poly1305.h
- src/lib/modes/aead/chacha20poly1305/chacha20poly1305.cpp